/*******************************************************************************
* FILE NAME: iplatfrm.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains a class that sets static variables that determine       *
*   the runtime operating system (platform)                                    *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/

/* Same priority as ibase.cpp.  This must be the first! */
#pragma priority ( -2147482624)

#define INCL_DOSMISC
#define INCL_DOSERRORS
#include <os2.h>
#include "iplatfrm.hpp"

/*------------------------------------------------------------------------------
| IPlatform::numProcessors()                                                   |
------------------------------------------------------------------------------*/
int IPlatform :: numProcessors()
{
   unsigned long sysInfoBuff[1] = {0};
   DosQuerySysInfo(26, 26, (void *)sysInfoBuff, sizeof sysInfoBuff);
   return sysInfoBuff[0];
}
